/* ---------------------------------------------------------------------------
   eibdrv_fl.c
   ---------------------------------------------------------------------------
   eibdrv_fl Version 0.2.1
   Copyright (C) 2002, Wolfgang Tumfart
                       Donaustrasse 104/9
                       A-2344 Maria Enzersdorf
                       Austria (Europe)
                       tumfart@auto.tuwien.ac.at

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   675 Mass Ave, Cambridge, MA 02139, USA.
   --------------------------------------------------------------------------- */

/* ---------------------------------------------------------------------------
   This file represents only a rough and incomplete implementation of
   some functions to access the Forms Library for buidling the GUI of
   all eibdrv-Tools.
   --------------------------------------------------------------------------- */

/* ---------------------------------------------------------------------------
   FormsLibrary is copyrighted by T.C. Zhao and Mark Overmars. It is not
   public domain, but may be used for running publically available free
   software.
   --------------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include "forms.h"
#include "eibdrv_fl.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <errno.h>

int errutility;


int bin_input_filter(FL_OBJECT *obj, const char *old, const char *cur, int c)
{  if ((c<48)||(c>49))
      return FL_INVALID|FL_RINGBELL;
   else
      return FL_VALID;
}



int hex_input_filter(FL_OBJECT *obj, const char *old, const char *cur, int c)
{  if ((c<48)||((c>57)&&(c<65))||((c>70)&&(c<97))||(c>102))
      return FL_INVALID|FL_RINGBELL;
   else
      return FL_VALID;
}



int dec_input_filter(FL_OBJECT *obj,const char *old,const char *cur,int c)
{  if ((c<48)||(c>57))
      return FL_INVALID|FL_RINGBELL;
   else
      return FL_VALID;
}

int asciiID_input_filter2(FL_OBJECT *obj,const char *old,const char *cur,int c)
{  switch(strlen(old))
   {   case 0: 
       case 1:
       case 2: if (((c>=48)&&(c<=57))||((c>=65)&&(c<=90)))
                  return FL_VALID;
               else
                  return FL_INVALID|FL_RINGBELL;
       case 3: 
       case 5: if (((c>=48)&&(c<=57))||((c>=65)&&(c<=70)))
                  return FL_VALID;
               else
                  return FL_INVALID|FL_RINGBELL;
       case 4: if (c==46)
                  return FL_VALID;
               else
                  return FL_INVALID|FL_RINGBELL;
   }
}



long BinToLong(char *Bin)
{  
   char *BinValue;
   long DecValue=0;
   
   if (strlen(Bin)>32)
   {  errutility=-2;
      return 0;
   }
   else
   {  for (BinValue=Bin;*BinValue!='\0';BinValue++)
         switch(*BinValue)
         {  case '0' : DecValue=DecValue*2;   break;
            case '1' : DecValue=DecValue*2+1; break;
            default  : errutility=-1;
                       return 0;
                       break;
         }
      errutility=0;
      return DecValue;
   }
}



char *BinToHex(char *Bin,char *Hex)
{  int Length=strlen(Bin);
   char *help=(char *)malloc((Length+4)*sizeof(char));
   char help2[5];
   char *help3;
   char *BinCode[16][2]={{"0000","0"},
                         {"0001","1"},
                         {"0010","2"},
                         {"0011","3"},
                         {"0100","4"},
                         {"0101","5"},
                         {"0110","6"},
                         {"0111","7"},
                         {"1000","8"},
                         {"1001","9"},
                         {"1010","A"},
                         {"1011","B"},
                         {"1100","C"},
                         {"1101","D"},
                         {"1101","E"},
                         {"1111","F"}};
   int i,j;
      
   strcpy(help,"");
   for (i=1;i<=(div(Length,4)).rem;i++)
      strcat(help,"0");
   strcat(help,Bin);
   help3=help;
   while (*help3!='\0')
   {  for (i=0;i<4;i++)
      {  if ((*help3!='0')&&(*help3!='1'))
         {   strcpy(Hex,"");
             return Hex;
         }
         else 
         {  help2[i]=*help3;
            help3++;
         }
      }
      help2[4]='\0';
      j=0;
      while (strcmp(BinCode[j][0],&help2[0])!=0)
         j++;
      strcat(Hex,BinCode[j][1]);
   }
   return Hex;
}



char *HexToBin(char *Hex,char *Bin)
{  char *help2;
   int i;
   int help;
   char *BinCode[22]={"0000","0001","0010","0011","0100","0101","0110","0111",
                     "1000","1001","1010","1011","1100","1101","1101","1111",
                     "1010","1011","1100","1101","1101","1111"};

   for (help2=Hex;(*help2)!='\0';help2++)
   {   help=(int)*help2;

       if ((help>=48)&&(help<=57))
          strcat(Bin,BinCode[help-48]);
       else if ((help>=65)&&(help<=70))
          strcat(Bin,BinCode[help-55]);
       else if ((help>=97)&&(help<=102))
          strcat(Bin,BinCode[help-81]);
       else 
       {  strcpy(Bin,"");
          errutility=-2;
          return Bin;
       }
   }
   errutility=0;
   help2=strchr(Bin,'1');
   if (help2!=NULL)
      strcpy(Bin,help2);
   else
      strcpy(Bin,"0");
   return Bin;
}


int hextobin(char *hex,char *bin)
{  char *help2;
   int i;
   int help;
   char *binCode[22]={"0000","0001","0010","0011","0100","0101","0110","0111",
                     "1000","1001","1010","1011","1100","1101","1101","1111",
                     "1010","1011","1100","1101","1101","1111"};

   strcpy(bin,"");                    
   for (help2=hex;*help2!='\0';help2++)
   {   help=(int)*help2;
       if ((help>=48)&&(help<=57))
          strcat(bin,binCode[help-48]);
       else if ((help>=65)&&(help<=70))
          strcat(bin,binCode[help-55]);
       else if ((help>=97)&&(help<=102))
          strcat(bin,binCode[help-81]);
       else 
       {  errutility=-2;
          return 0;
       }
   }
   errutility=0;
   help2=strchr(bin,'1');
   if (help2!=NULL)
      strcpy(bin,help2);
   else
      strcpy(bin,"0");
   return strlen(bin);
}


void IntToString2(int value,char *string)
{  char help[2];
   int stelle;

   stelle=value%10;
   help[0]='0'+stelle;
   help[1]='\0';

   if (value/10>0) IntToString2(value/10,string);

   strcat(string,&help[0]);
}


void AsciiChipID_to_HexChipID2(char *AsciiChipID, char *HexChipID)
{  int i;
   int length=strlen(AsciiChipID);
   char helpHex[3];
   
   strcpy(HexChipID,"");
   i=0;
   while((i<=(length-1))&&(i<=2))
   {  sprintf(&helpHex[0],"%x",((*(AsciiChipID+i))-'0'+0x30));
      strcat(HexChipID,&helpHex[0]);
      i++;
   }
   if (length>=4)
   {  sprintf(&helpHex[0],"%x",((*(AsciiChipID+3))-'0'));
      strcat(HexChipID,&helpHex[0]);
   }
   if (length>=6)
   {  sprintf(&helpHex[0],"%x",((*(AsciiChipID+5))-'0'));
      strcat(HexChipID,&helpHex[0]);
   }
}

int read_ValueEditfield(FL_OBJECT *obj,int base,unsigned long *value)
{  int length=strlen(fl_get_input(obj));
   char *helpHexPtr=(char *)malloc(9*sizeof(char));
   char *helpHex2Ptr=(char *)malloc(11*sizeof(char));
   
//   printf("ReadValueEditfield mit Base=%i\n",base);
   switch(base)
   {  case 2:
      case 10:
      case 16: *value=strtoul(fl_get_input(obj),NULL,base);
               break;
      case 90: *value=strtoul(fl_get_input(obj),NULL,16);
               break;
      case 91: AsciiChipID_to_HexChipID2((char *)fl_get_input(obj),helpHexPtr);
               *value=strtoul(helpHexPtr,NULL,16);
               break;
   }
   switch(errno)
   {  case 0:      return length;
                   break;
      case ERANGE: return -1;
                   break;
      default:     return -2;
                   break;
   }
   free(helpHexPtr);
}


void HexChipID_to_AsciiChipID2(char *HexChipID, char *AsciiChipID)
{   int i,j=0;
    char hex_help[3];
    char ascii_help[7];
    
    for (i=0;i<=4;i+=2)
    {   hex_help[0]=(*((HexChipID)+i));
        hex_help[1]=(*((HexChipID)+i+1));
        hex_help[2]='\0';
        ascii_help[j]=(int)strtol(&hex_help[0],NULL,16);
        j++;
    }      
    ascii_help[3]=(*((HexChipID)+6));
    ascii_help[4]='.';
    ascii_help[5]=(*((HexChipID)+7));
    ascii_help[6]='\0';
    
    strcpy(AsciiChipID,&ascii_help[0]);
}


int write_ValueEditfield(FL_OBJECT *obj,int base,unsigned long value,int maxchars)
{  int i;
   int l;
   int ReturnValue;
   char *objstring=(char *)malloc(33*sizeof(char));
   char *helpstring=(char *)malloc(33*sizeof(char));
   char *nullstring=(char *)malloc(33*sizeof(char));
   
   strcpy(objstring,"");
   strcpy(helpstring,""); 
   strcpy(nullstring,"0000000000000000000000000000000000");
   
   if (value>ULONG_MAX)
      ReturnValue=-1;
   else
   {  switch(base)
      {  case 10: l=sprintf(objstring,"%li",value);
                  break;
         case 16: l=sprintf(objstring,"%x",value);
                  break;
         case 2:  sprintf(helpstring,"%x",value);
                  l=hextobin(helpstring,objstring);
                  break;
         case 90: sprintf(objstring,"%x",value);
                  l=strlen(objstring);        
                  break;
         case 91: sprintf(helpstring,"%x",value);
                  HexChipID_to_AsciiChipID2(helpstring,objstring);
                  l=strlen(objstring);
                  break;
      }
      if (l<0)
         ReturnValue=-2;
      else 
      { /* if (maxchars>l)
         {  strncat(helpstring,nullstring,maxchars-l);
            strcat(helpstring,objstring);
            fl_set_input(obj,helpstring);
         }
         else  */
            fl_set_input(obj,objstring);
         ReturnValue=l;
      }
   }
   free(objstring);
   free(helpstring);
   free(nullstring);
   return ReturnValue;
}



void line_count(char *s, int *LineCount, int *MaxCharCount)
{  char *help;
   int CharCount=0;

   (*MaxCharCount)=0;
   (*LineCount)=0;

   help=s;
   while(*help!='\0')
   {   if (*help=='\n')      /* Lines ending with \n                  */
       {  (*LineCount)++;
          if (CharCount>(*MaxCharCount))
             (*MaxCharCount)=CharCount;
          CharCount=0;
       }
       else
          CharCount++;
       help++;
   }
   if (CharCount>0)          /* Last Line not ending with \n          */
   {   (*LineCount)++;
       if (CharCount>(*MaxCharCount))
          (*MaxCharCount)=CharCount;
   }
}   


int count_Lines(char *Text)
{  char *help_Text=Text;
   int CharCount=0;
   int LineCount=0;

   while(*help_Text!='\0')
   {  if (*help_Text=='\n')      /* Lines ending with \n                  */
      {  LineCount++;
         CharCount=0;
      }
      else
         CharCount++;
      help_Text++;
   }
   if (CharCount>0)          /* Last Line not ending with \n          */
      LineCount++;
      
   return LineCount;
}   



void get_line(char **sPtr, char *TextLine)
{  char *help;
   int CharCount=0;
   
   help=*sPtr;
   while((*help!='\n')&&(*help!='\0')) 
   {  CharCount++;
      help++;
   }
   strcpy(TextLine,"");
   strncat(TextLine,*sPtr,CharCount);
   (*sPtr)+=(CharCount+1);
}   



int info_panel(int x, int y, int w, int InfoPanelType, char *InfoPanelTitle, char *text)
{
   FL_FORM *InfoPanelForm;
   FL_OBJECT *OkBtn;
   FL_OBJECT *ContinueBtn;
   FL_OBJECT *CancelBtn;
   FL_OBJECT *Obj;
   FL_OBJECT *Box1,*Box2,*Text1;   
   char *TextLine;
   char *help;
   
   int LineCount;
   int MaxCharCount;
   int Box2Y;
   int i;
   
   help=text;
   line_count(help,&LineCount,&MaxCharCount);
   TextLine=(char *)malloc((MaxCharCount+1)*sizeof(char));

   Box2Y=60+LineCount*15;    /* Starting point for the Button-Box     */
   
   InfoPanelForm=fl_bgn_form(FL_NO_BOX,w,Box2Y+70);
      Box1=fl_add_box(FL_UP_BOX,0,0,w,Box2Y,"");
         fl_set_object_color(Box1,BOX_COL1,BOX_COL2);
         fl_set_object_lcol(Box1,LABEL_COL);
      help=text;
      for (i=0;i<LineCount;i++)
      {   get_line(&help,TextLine);
          Text1=fl_add_text(FL_NORMAL_TEXT,20,30+15*i,w-40,15,TextLine);
             fl_set_object_lcol(Text1,LABEL_COL);
      }
      free(TextLine);
      Box2=fl_add_box(FL_UP_BOX,0,Box2Y,w,70,"");
         fl_set_object_color(Box2,BOX_COL1,BOX_COL2);
         fl_set_object_lcol(Box2,LABEL_COL);
      switch(InfoPanelType)
      {   case NORMAL_INFOPANEL:      OkBtn=fl_add_button(FL_NORMAL_BUTTON,20,Box2Y+20,80,30,"Ok");
                                         fl_set_object_boxtype(OkBtn,FL_UP_BOX);
                                         fl_set_object_color(OkBtn,BUTTON_COL1,BUTTON_COL2);
                                         fl_set_object_lcol(OkBtn,LABEL_COL);
                                      break;
          case CONTINUE_CANCEL_PANEL: ContinueBtn=fl_add_button(FL_NORMAL_BUTTON,20,Box2Y+20,80,30,"Continue");
                                         fl_set_object_boxtype(ContinueBtn,FL_UP_BOX);
                                         fl_set_object_color(ContinueBtn,BUTTON_COL1,BUTTON_COL2);
                                         fl_set_object_lcol(ContinueBtn,LABEL_COL);
                                      CancelBtn=fl_add_button(FL_NORMAL_BUTTON,120,Box2Y+20,80,30,"Cancel");
                                         fl_set_object_boxtype(CancelBtn,FL_UP_BOX);
                                         fl_set_object_color(CancelBtn,BUTTON_COL1,BUTTON_COL2);
                                         fl_set_object_lcol(CancelBtn,LABEL_COL);
                                      break;
      }
   fl_end_form();
   fl_set_form_geometry(InfoPanelForm,x,y,w,Box2Y+70);
   fl_show_form(InfoPanelForm,FL_PLACE_GEOMETRY,FL_TRANSIENT,InfoPanelTitle);
   
   while(1==1)
   {   Obj=fl_do_forms();
       if (Obj==OkBtn)
       {   fl_hide_form(InfoPanelForm);
           return OKBTN;
       }
       else if (Obj==ContinueBtn)
       {   fl_hide_form(InfoPanelForm);
           return CONTINUEBTN;
       }
       else if (Obj==CancelBtn)
       {   fl_hide_form(InfoPanelForm);
           return CANCELBTN;
       }
   }
}

void fl_ext_activate_button(FL_OBJECT *Button)
{  fl_activate_object(Button);
   fl_set_object_lcol(Button,LABEL_COL);
}

void fl_ext_activate_object(FL_OBJECT *obj)
{  fl_ext_activate_button(obj);
}

void fl_ext_deactivate_button(FL_OBJECT *Button)
{  fl_deactivate_object(Button);
   fl_set_object_lcol(Button,FL_INACTIVE_COL);
}

void fl_ext_deactivate_object(FL_OBJECT *obj)
{  fl_ext_deactivate_button(obj);
}

int load_DefaultParam(int (*read_Param_from_File)(char *,void *),void *Param,
                      void (*init_Param)(void *), 
                      char *DefaultFile)
{  int ReturnValue;
   switch(ReturnValue=(*read_Param_from_File)(DefaultFile,Param))
   {  case -1 : 
           {  char *Text1=(char *)malloc(1000*sizeof(char));
              char *Text2=(char *)malloc(1000+sizeof(char));
              strcpy(Text1,"File @20@0@5 ");
              strcat(Text1,DefaultFile);
              strcat(Text1,"\n@0@0@0 cannot be opened for reading the default\n");
              strcat(Text1,"parameter.");
              strcpy(Text2,"Press@30@0@1 Continue@77@0@0 to set all parameter\n");
              strcat(Text2,"to initial values or press@112@0@1 Cancel@147@0@0 to\n");
              strcat(Text2,"restore the previous values.");
//              if (fl_ext_panel(30,30,380,145,FL_EXT_PANEL_CONTINUE_CANCEL,
//                          "Load Default Parameter - Error",Text1,Text2)==FL_EXT_PANEL_CONTINUEBTN)
              {  (*init_Param)(Param);
                 ReturnValue=-3;
              }
              free(Text1);
              free(Text2);
           }
           break;
      case -2 : 
           {  char *Text1=(char *)malloc(1000*sizeof(char));
              char *Text2=(char *)malloc(1000+sizeof(char));
              strcpy(Text1,"File @20@0@5 ");
              strcat(Text1,DefaultFile);
              strcat(Text1,"\n@0@0@0 is not a valid parameter file.");
              strcpy(Text2,"Press@30@0@1 Continue@77@0@0 to set all parameter\n");
              strcat(Text2,"to initial values or press@112@0@1 Cancel@147@0@0 to\n");
              strcat(Text2,"restore the previous values.");
//              if (fl_ext_panel(30,30,380,145,FL_EXT_PANEL_CONTINUE_CANCEL,
//                          "Load Default Parameter - Error",Text1,Text2)==FL_EXT_PANEL_CONTINUEBTN)
              {  (*init_Param)(Param);
                 ReturnValue=-4;
              }
              free(Text1);
              free(Text2);
           }
           break;
   }
   return ReturnValue;
}  


int save_DefaultParam(int (*write_Param_to_File)(char *,void *),void *Param,
                      char *DefaultFile)
{  int ReturnValue;
   switch(ReturnValue=(*write_Param_to_File)(DefaultFile,Param))
   {  case -1 : 
           {  char *Text1=(char *)malloc(1000*sizeof(char));
              char *Text2=(char *)malloc(1000+sizeof(char));
              strcpy(Text1,"File @20@0@5 ");
              strcat(Text1,DefaultFile);
              strcat(Text1,"\n@0@0@0 cannot be opened for writing the default parameter.");
              strcpy(Text2,"Press@30@0@1 Ok@50@0@0 to dismiss this message.");
//              fl_ext_panel(30,30,420,110,FL_EXT_PANEL_OK,
//                          "Save Default Parameter - Error",Text1,Text2);
              free(Text1);
              free(Text2);
           }
           break;
      case -2 : 
           {  char *Text1=(char *)malloc(1000*sizeof(char));
              char *Text2=(char *)malloc(1000+sizeof(char));
              strcpy(Text1,"An error occured when writing the default parameter\n");
              strcat(Text1,"to File @33@0@5 ");
              strcat(Text1,DefaultFile);
              strcpy(Text2,"Press@30@0@1 Ok@50@0@0 to dismiss this message.");
//              fl_ext_panel(30,30,420,110,FL_EXT_PANEL_OK,
//                          "Save Default Parameter - Error",Text1,Text2);
              free(Text1);
              free(Text2);
           }
           break;
   }
   return ReturnValue;
}  



char *check_ReadString(char *String)
{  char *helpChar1;
   char *helpChar2;
   char *ReadString;

   if (strcmp(String,"_EMPTYSTRING")==0)
   {  ReadString=(char *)malloc(2*sizeof(char));
      strcpy(ReadString,"");
   }
   else
   {  helpChar1=String;
      ReadString=(char *)malloc((strlen(String)+1)*sizeof(char));
      helpChar2=ReadString;
      while (*helpChar1!='\0')

      {  if (*helpChar1=='\\')
         {  helpChar1++;
            if (*helpChar1=='_')
            {  *helpChar2=' '; 
               helpChar2++;
            }
            else if (*helpChar1=='\\')
            {  *helpChar2='\\';
               helpChar2++;
            }
         }
         else
         {  *helpChar2=*helpChar1; 
            helpChar2++;
         }
         helpChar1++;
      }
      *helpChar2='\0';
   }
   return ReadString;
}


char *check_WriteString(char *String)
{  char *helpChar1;
   char *helpChar2;
   char *WriteString;

   if (strcmp(String,"")==0)
   {  WriteString=(char *)malloc(13*sizeof(char));
      strcpy(WriteString,"_EMPTYSTRING");
   }
   else
   {  helpChar1=String;
      WriteString=(char *)malloc((strlen(String)*2+1)*sizeof(char));
      helpChar2=WriteString;
      while (*helpChar1!='\0')
      {  if (*helpChar1==' ')
         {  *helpChar2='\\'; helpChar2++;
            *helpChar2='_';  helpChar2++;
         }
         else if (*helpChar1=='\\')
         {  *helpChar2='\\'; helpChar2++;
            *helpChar2='\\'; helpChar2++;
         }
         else 
         {  *helpChar2=(*helpChar1);  
            helpChar2++;
         }
         helpChar1++;
      }
      *helpChar2='\0';
   }
   return WriteString;
}
   
   
void fl_ext_formobjects_add_btn(FL_OBJECT **Btn,int Type,int x,int y,int width,int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Btn=obj=fl_add_button(Type,x,y,width,height,Title);
   fl_set_object_boxtype(obj,FL_UP_BOX);
   fl_set_object_color(obj,BUTTON_COL1,BUTTON_COL2);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);   
}

void fl_ext_formobjects_add_checkbtn(FL_OBJECT **Btn,int Type,int x,int y,int width,int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Btn=obj=fl_add_checkbutton(Type,x,y,width,height,Title);
   fl_set_object_boxtype(obj,FL_NO_BOX);
   fl_set_object_color(obj,CHECKBUTTON_COL1,CHECKBUTTON_COL2);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_lightbtn(FL_OBJECT **Btn,int Type,int x,int y,int width,int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Btn=obj=fl_add_lightbutton(Type,x,y,width,height,Title);
   fl_set_object_boxtype(obj,FL_UP_BOX);
   fl_set_object_color(obj,LIGHTBUTTON_COL1,LIGHTBUTTON_COL2);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);   
}

void fl_ext_formobjects_add_box(int Type,int x,int y,int width,int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   obj=fl_add_box(Type,x,y,width,height,Title);
   fl_set_object_color(obj,BOX_COL1,BOX_COL2);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);
}
   
void fl_ext_formobjects_add_box2(FL_OBJECT **Box,int Type,int x,int y,int width,int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Box=obj=fl_add_box(Type,x,y,width,height,Title);
   fl_set_object_color(obj,BOX_COL1,BOX_COL2);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);
}

   
void fl_ext_formobjects_add_browser(FL_OBJECT **Browser,int Type,int x,int y,int width, int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Browser=obj=fl_add_browser(Type,x,y,width,height,Title);
   fl_set_object_color(obj,BROWSER_COL1,BROWSER_COL2);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_choice(FL_OBJECT **Choice,int Type,int x,int y,int width,int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Choice=obj=fl_add_choice(Type,x,y,width,height,Title);
      fl_set_object_boxtype(obj,FL_DOWN_BOX);
      fl_set_object_color(obj,CHOICE_COL1,CHOICE_COL2);
      fl_set_object_lcol(obj,LABEL_COL);
      fl_set_object_resize(obj,howresize);
      fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_inp(FL_OBJECT **Inp,int Type,int x,int y,int width,
               int height,char *Title,int MaxChars,int ReturnType,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   *Inp=obj=fl_add_input(Type,x,y,width,height,Title);
//      fl_set_input_maxchars(obj,MaxChars);
//      fl_set_input_return(obj,ReturnType);
/*
#if FL_INCLUDE_VERSION == 81
      switch(Type)
      {  case FL_EXT_FORMOBJECT_UTCSU_BININPUT       : fl_set_input_filter(obj,bin_input_filter);
                                                       break;
         case FL_EXT_FORMOBJECT_UTCSU_HEXINPUT       : fl_set_input_filter(obj,hex_input_filter);
                                                       break;
         case FL_EXT_FORMOBJECT_UTCSU_DECINPUT       : fl_set_input_filter(obj,dec_input_filter);
                                                       break;
         case FL_EXT_FORMOBJECT_UTCSU_STRINGINPUT     : break;
         case FL_EXT_FORMOBJECT_UTCSU_DIRECTORYINPUT : break;
         case FL_EXT_FORMOBJECT_UTCSU_FILEINPUT      : break;
      }
#endif
*/
      fl_set_object_color(obj,INPUT_COL1,INPUT_COL2);
      fl_set_input_color(obj,INPUT_COLTEXT,INPUT_COLCUR);
      fl_set_object_lcol(obj,LABEL_COL);
      fl_set_object_resize(obj,howresize);
      fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_text(FL_OBJECT **Text,int boxtype,int x,int y,int width,
               int height,char *Label,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;

   *Text=obj=fl_add_text(FL_NORMAL_TEXT,x,y,width,height,Label);
   fl_set_object_boxtype(obj,boxtype);
   if (boxtype==FL_BORDER_BOX)
      fl_set_object_color(obj,TEXT_COL2,TEXT_COL2);
   else
      fl_set_object_color(obj,TEXT_COL1,TEXT_COL1);
   fl_set_object_lcol(obj,LABEL_COL);
   fl_set_object_resize(obj,howresize);
   fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_frame(int Type,int x,int y,int width,
               int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   obj=fl_add_frame(Type,x,y,width,height,Title);
      fl_set_object_color(obj,FRAME_COL1,FRAME_COL2);
      fl_set_object_lcol(obj,LABEL_COL);
      fl_set_object_resize(obj,howresize);
      fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_labelframe(int Type,int x,int y,int width,
               int height,char *Title,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   obj=fl_add_labelframe(Type,x,y,width,height,Title);
      fl_set_object_color(obj,LABELFRAME_COL1,LABELFRAME_COL2);
      fl_set_object_lcol(obj,LABEL_COL);
      fl_set_object_resize(obj,howresize);
      fl_set_object_gravity(obj,NWgravity,SEgravity);
}


void fl_ext_formobjects_add_bitmap(int Type,int x,int y,int width,
               int height,char *Title,char *BitmapFile,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   
   obj=fl_add_bitmap(Type,x,y,width,height,Title);
      fl_set_bitmap_file(obj,BitmapFile);
      fl_set_object_resize(obj,howresize);
      fl_set_object_gravity(obj,NWgravity,SEgravity);
}

void fl_ext_formobjects_add_counter(FL_OBJECT **counter,int Type,int x,int y,int width,
               int height,char *Title,int lalign,
               double min_bound,double max_bound,double small_step,double large_step,int prec,
               unsigned howresize,unsigned NWgravity,unsigned SEgravity)
{  FL_OBJECT *obj;
   *counter=obj=fl_add_counter(Type,x,y,width,height,Title);
      fl_set_object_color(obj,COUNTER_COL1,COUNTER_COL2);
      fl_set_object_lcol(obj,LABEL_COL);
      fl_set_object_lalign(obj,lalign);
      fl_set_counter_precision(obj,prec);
      fl_set_counter_bounds(obj,min_bound,max_bound);
      fl_set_counter_step(obj,small_step,large_step);
      fl_set_object_resize(obj,howresize);
      fl_set_object_gravity(obj,NWgravity,SEgravity);
}
   




void expand_TextLine(char **TextLine, int CharCount);
int get_Line(char **Text, char **TextLine);
void *fl_ext_panel1(PanelContent *Content,void *UserData,
                    void (*Panel_cb)(void *,int));
void *fl_ext_panel2(PanelContent *Content,void *UserData,
                    void (*Panel_cb)(void *,int));



PanelType *getPanel(void)
{  PanelType *help=(PanelType *)fl_calloc(1,sizeof(PanelType));
   return help;
}

void returnPanel(PanelType *Panel)
{  fl_free_form(Panel->Form);
   free(Panel);
}


PanelContent *getPanelContentA(int size)
{  int i;
   PanelContent *help;

   if (size==0) return NULL;

   help=(PanelContent *)malloc(size*sizeof(PanelContent));
   for (i=0;i<size;i++)
   {  (help+i)->Type=1;
      (help+i)->X=0;
      (help+i)->Y=0;
      (help+i)->Width=1;
      (help+i)->Height=1;
      (help+i)->Title=(char *)malloc(sizeof(char));  *((help+i)->Title)='\0';
      (help+i)->Text1=(char *)malloc(sizeof(char));  *((help+i)->Text1)='\0';
      (help+i)->Text2=(char *)malloc(sizeof(char));  *((help+i)->Text2)='\0';
   }
   return help;
}

void returnPanelContentA(PanelContent *ContentA,int size)
{  int i;

   if (size==0) return;

   for (i=0;i<size;i++)
   {  free((ContentA+i)->Title);
      free((ContentA+i)->Text1);
      free((ContentA+i)->Text2);
   }
   free(ContentA);
}

int write_str(FILE *file,char *str)
{  int i;
   int len=strlen(str);
   char *ch;

   if (fprintf(file," %i ",len)<0)
      return -1;

   for (i=0,ch=str;i<len;i++,ch++)
      if (fputc((int)(*ch),file)==EOF)
         return -1;
   return 0;
}


int write_PanelContentA(char *file,PanelContent *ContentA,int size)
{  int i;
   FILE *panel_file;
   PanelContent *help;

   if ((panel_file=fopen(file,"w"))==NULL)
      return -1;

   if (fprintf(panel_file,"%i",size)<0)
      goto fail_write;

   for (i=0,help=ContentA;i<size;i++,help++)
   {  if (fprintf(panel_file," %i %i %i %i %i",help->Type,help->X,help->Y,help->Width,help->Height)<0)
         goto fail_write;
      if (write_str(panel_file,help->Title)!=0) goto fail_write;
      if (write_str(panel_file,help->Text1)!=0) goto fail_write;
      if (write_str(panel_file,help->Text2)!=0) goto fail_write;
   }
   fclose(panel_file);
   return 0;

   fail_write: fclose(panel_file);
               return -2;
}

int read_str(FILE *panel_file,char **str)
{  int i,len;
   char *help;

   if (fscanf(panel_file,"%i",&len)==EOF) return -1;
   help=(char *)malloc((len+1)*sizeof(char));

   if (len>0)
   {  fgetc(panel_file);
      for (i=0;i<len;i++)
         if ((*(help+i)=fgetc(panel_file))==EOF)
         {  free(help);
            return -1;
         }
   }

   *(help+len)='\0';
   *str=help;
   return 0;
}


int read_PanelContentA(char *file,PanelContent **ContentA)
{  int i,size;
   FILE *panel_file;
   PanelContent *helpA;

   if ((panel_file=fopen(file,"r"))==NULL)
      return -1;

   if (fscanf(panel_file,"%i",&size)==EOF)
   {  fclose(panel_file);
      return -2;
   }

   helpA=(PanelContent *)malloc(size*sizeof(PanelContent));
   for (i=0;i<size;i++)
   {  if (fscanf(panel_file," %i %i %i %i %i",
              &((helpA+i)->Type),&((helpA+i)->X),&((helpA+i)->Y),&((helpA+i)->Width),&((helpA+i)->Height))==EOF)
         goto fail_read;
      if (read_str(panel_file,&((helpA+i)->Title))!=0) goto fail_read;
      if (read_str(panel_file,&((helpA+i)->Text1))!=0) goto fail_read;
      if (read_str(panel_file,&((helpA+i)->Text2))!=0) goto fail_read;
   }
   fclose(panel_file);
   *ContentA=helpA;
   return size;

   fail_read: free(helpA);
              fclose(panel_file);
              return -2;
}



void expand_TextLine(char **TextLine, int CharCount)
{  char *help_TextLine=(char *)malloc((strlen(*TextLine)+CharCount+1)*sizeof(char));
   strcpy(help_TextLine,*TextLine);
   free(*TextLine);
   *TextLine=help_TextLine;
}


int get_Line(char **Text, char **TextLine)
{
   int CharCount=0;
   char *help_Text=*Text;

   *TextLine=(char *)malloc(sizeof(char));
   strcpy(*TextLine,"");

   while ((*help_Text!='\n')&&(*help_Text!='\0'))
   {  if (*help_Text=='@')  // Steueranweisung Beginn
      {  if (CharCount>0)              // vorhergehenden String ablegen
         {  expand_TextLine(TextLine,CharCount);
            strncat(*TextLine,*Text,CharCount);
            (*Text)+=CharCount;
            CharCount=0;
         }
         while (*help_Text!=' ')       // Steueranweisung ueberlesen
         { (*Text)++;
           help_Text++;
         }
         (*Text)++;                    // Steueranweisung Ende
         help_Text++;
      }
      else
      {  CharCount++;                  // String einlesen
         help_Text++;
      }
   }

   if (CharCount>0)                    // gelesenen String ablegen
   {  expand_TextLine(TextLine,CharCount);
      strncat(*TextLine,*Text,CharCount);
   }

   if (*help_Text=='\n')               // Zeilentrenner ueberlesen
      (*Text)+=(CharCount+1);
   else                                // am Textende bleiben
      (*Text)+=CharCount;

   return strlen(*TextLine);
}


void Btn_cb(FL_OBJECT *Btn,long BtnCode)
{  PanelType *helpPanel=(PanelType *)Btn->form->u_vdata;


   if (*helpPanel->Panel_cb!=NULL)
   {  fl_hide_form(helpPanel->Form);
      (*helpPanel->Panel_cb)(helpPanel->UserData,(int)BtnCode);
      returnPanel(helpPanel);
   }
}



void *fl_ext_panel1(PanelContent *Content,void *UserData,
                    void (*Panel_cb)(void *,int))
{  return ((PanelType *)fl_ext_ppanel1(Content,UserData,Panel_cb))->Form;
}


void *fl_ext_ppanel1(PanelContent *Content,void *UserData,
                    void (*Panel_cb)(void *,int))
{  PanelType *Panel;

   Panel=getPanel();
   switch(Content->Type)
   {  case FL_EXT_PANEL_OK:
      case FL_EXT_PANEL_CONTINUE_CANCEL:
              Panel->Form=(FL_FORM *)fl_ext_panel2(Content,UserData,Panel_cb);
              break;
      case FL_EXT_BROWSERPANEL_OK:
      case FL_EXT_BROWSERPANEL_CONTINUE_CANCEL:
              Panel->Form=(FL_FORM *)fl_ext_panel2(Content,UserData,Panel_cb);
              break;
   }
   Panel->Form->u_vdata=Panel;
   Panel->UserData=UserData;
   Panel->Panel_cb=Panel_cb;

   fl_addto_form(Panel->Form);
      switch(Content->Type)
      {  case FL_EXT_PANEL_OK :
         case FL_EXT_BROWSERPANEL_OK :
                 fl_ext_formobjects_add_btn(&Panel->OkBtn,FL_NORMAL_BUTTON,
                       Content->Width-110,Content->Height-45,90,25,"OK",
                       FL_RESIZE_NONE,FL_SouthEast,FL_SouthEast);
                    fl_set_object_callback(Panel->OkBtn,Btn_cb,FL_EXT_PANEL_OKBTN);
                 break;
         case FL_EXT_PANEL_CONTINUE_CANCEL :
         case FL_EXT_BROWSERPANEL_CONTINUE_CANCEL :
                 fl_ext_formobjects_add_btn(&Panel->ContinueBtn,FL_NORMAL_BUTTON,
                       Content->Width-110,Content->Height-80,90,25,"Continue",
                       FL_RESIZE_NONE,FL_SouthEast,FL_SouthEast);
                    fl_set_object_callback(Panel->ContinueBtn,Btn_cb,FL_EXT_PANEL_CONTINUEBTN);
                 fl_ext_formobjects_add_btn(&Panel->CancelBtn,FL_NORMAL_BUTTON,
                       Content->Width-110,Content->Height-45,90,25,"Cancel",
                       FL_RESIZE_NONE,FL_SouthEast,FL_SouthEast);
                    fl_set_object_callback(Panel->CancelBtn,Btn_cb,FL_EXT_PANEL_CANCELBTN);
                 break;
      }
      if ((Content->Type==FL_EXT_BROWSERPANEL_OK)||
          (Content->Type==FL_EXT_BROWSERPANEL_CONTINUE_CANCEL))
      {  fl_ext_formobjects_add_browser(&Panel->Browser,
               FL_NORMAL_BROWSER,20,20,Content->Width-150,Content->Height-40,"",
               FL_RESIZE_ALL,FL_NorthWest,FL_SouthEast);
            fl_set_browser_fontstyle(Panel->Browser,FL_FIXED_STYLE);
            fl_addto_browser(Panel->Browser,Content->Text1);
      }

   fl_end_form();


   if ((Content->Type==FL_EXT_BROWSERPANEL_OK)||
       (Content->Type==FL_EXT_BROWSERPANEL_CONTINUE_CANCEL))
   {  fl_set_form_position(Panel->Form,Content->X,Content->Y);
      fl_show_form(Panel->Form,FL_PLACE_POSITION,FL_FULLBORDER,Content->Title);
   }
   else
   {  fl_set_form_geometry(Panel->Form,Content->X,Content->Y,Content->Width,Content->Height);
      fl_show_form(Panel->Form,FL_PLACE_GEOMETRY,FL_FULLBORDER,Content->Title);
   }

   return Panel;
}


void *fl_ext_panel2(PanelContent *Content,void *UserData,
                    void (*Panel_cb)(void *,int))
{  FL_FORM *Form;
   FL_OBJECT *Text;
   FL_OBJECT *ArrowBox;

   int Offset_x=FL_EXT_PANEL_OFFSET_X;  int Text_x=Offset_x;  int Tab_x;
   int Offset_y=FL_EXT_PANEL_OFFSET_Y;  int Text_y=Offset_y;  int Tab_y;

   int Arrow_x=Offset_x;
   int Arrow_y;

   int TextWidth=Content->Width-2*FL_EXT_PANEL_BORDER_WIDTH;
   int LineHeight=FL_EXT_PANEL_LINEHEIGHT;

   int i=0;
   int CharCount;
   char *help_Text;
   char *help_PanelText;
   char *TextSegment;
   char *p;

   Form=fl_bgn_form(FL_FLAT_BOX,Content->Width,Content->Height);
   help_PanelText=Content->Text1;
   if ((Content->Type != FL_EXT_BROWSERPANEL_OK) &&
       (Content->Type != FL_EXT_BROWSERPANEL_CONTINUE_CANCEL))
   {  do
      {  i++;
         while (*help_PanelText!='\0')
         {  if (*help_PanelText=='\n')
            {  Text_x=Offset_x;
               Text_y+=LineHeight;
               help_PanelText++;
            }
            else if ((*help_PanelText=='@')&&(*(help_PanelText+1)!='@'))
            {  sscanf(help_PanelText,"@%d@%d",&Tab_x,&Tab_y);
               Text_x=Offset_x+Tab_x;
               Text_y+=Tab_y;
               while (*help_PanelText!=' ')
                  help_PanelText++;
               help_PanelText++;
            }
            else
            {  CharCount=0;
               help_Text=help_PanelText;
               while ((*help_PanelText!='\n')&&
                      (*help_PanelText!='\0') &&
                      ((*help_PanelText!='@') || ((*help_PanelText=='@')&&(*(help_PanelText+1)=='@'))
                                              || ((*help_PanelText=='@')&&(*(help_PanelText-1)=='@'))  ))
               {  CharCount++;
                  help_PanelText++;
               }
               TextSegment=(char *)malloc((CharCount+1)*sizeof(char));
               *TextSegment='\0';
               strncat(TextSegment,help_Text,CharCount);

               while ((p=strstr(TextSegment,"@@"))!=NULL)
                  strcpy(p+1,p+2);

               Text=fl_add_text(FL_NORMAL_TEXT,Text_x,Text_y,TextWidth-Text_x,LineHeight,TextSegment);
                  fl_set_object_lcol(Text,FL_EXT_PANEL_DEFAULT_COL);
               free(TextSegment);
            }
         }
         if (i==1)
         {  help_PanelText=Content->Text2;
            Offset_x+=30;
            Text_x=Offset_x;
            Text_y+=(2*LineHeight);
            Arrow_y=Text_y;
         }
      } while (i<2);

      if (*(Content->Text2)!='\0')
      {  ArrowBox=fl_add_box(FL_NO_BOX,Arrow_x,Arrow_y,30,30,"@->");
            fl_set_object_color(ArrowBox,FL_EXT_PANEL_BOX_COL1,FL_EXT_PANEL_BOX_COL2);
            fl_set_object_lcol(ArrowBox,FL_EXT_PANEL_ICON_COL);

      }
   }
   fl_end_form();

   return Form;
}


void fl_ext_hide_panel(PanelType *Panel)
{  fl_hide_form(Panel->Form);
}


void fl_ext_free_panel(PanelType *Panel)
{  returnPanel(Panel);
}


void fl_ext_cancel_panel(PanelType *Panel)
{  fl_hide_form(Panel->Form);
   (*Panel->Panel_cb)(Panel->UserData,FL_EXT_PANEL_NULLBTN);
   returnPanel(Panel);
}


#define FL_EXT_INDICATOR_TIMEOK 0         /* 00:00 <= Zeit <= 99:59            */
#define FL_EXT_INDICATOR_TIMEOVERFLOW 1   /* Zeit > 99:59                      */


IndicatorType *getIndicator(void);
void returnIndicator(IndicatorType *helpIndicator);
int calc_Time(char *TimeString,int Seconds);

void fl_ext_time_indicator(IndicatorType *Indicator,int Mode);
void fl_ext_start_indicator(IndicatorType *Indicator);
void fl_ext_reset_indicator(IndicatorType *Indicator);
void fl_ext_update_indicator(IndicatorType *Indicator,
                             int StateNew, double PercentValueNew);
IndicatorType *fl_ext_add_indicator(FL_FORM *Form,int PosX,int PosY,
                int Width,int Height,int FL_Gravity);
void fl_ext_free_indicator(IndicatorType *Indicator);


IndicatorType *getIndicator(void)
{  IndicatorType *help=(IndicatorType *)fl_calloc(1,sizeof(IndicatorType));

   help->PercentValue=-1;
   help->State=FL_EXT_INDICATOR_INITIAL;
   return help;
}


void returnIndicator(IndicatorType *helpIndicator)
{  free (helpIndicator);     /* Das das Indikatorpanel in ein vorhandenes Form */
                             /* eingebettet wird, werden die visuellen         */
                             /* mit Freigabe dieses Forms freigegeben.         */
}


int calc_Time(char *TimeString,int Seconds)
{  int Hours, Minutes;

   Minutes=Seconds/60;   Seconds=Seconds%60;
   Hours  =Minutes/60;   Minutes=Minutes%60;

   if (Hours<100)
   {  sprintf(TimeString,"%02i:%02i:%02i",Hours,Minutes,Seconds);
      return FL_EXT_INDICATOR_TIMEOK;
   }
   else
      return FL_EXT_INDICATOR_TIMEOVERFLOW;
}


void fl_ext_time_indicator(IndicatorType *Indicator,int Mode)
{  time_t ActualTime;
   int Seconds;
   char help_TimeText[9];

   ActualTime=time(NULL);
   Seconds=(int)(difftime(ActualTime,Indicator->StartTime));
   if (calc_Time(help_TimeText,Seconds)==FL_EXT_INDICATOR_TIMEOK)
      fl_set_object_label(Indicator->ActualTimeText,help_TimeText);
   else
      fl_set_object_label(Indicator->ActualTimeText,"Overflow");

   if ((Mode==FL_EXT_INDICATOR_ACTUAL_AND_ESTIMATED_TIME)&&(Indicator->PercentValue>0))
   {  if (calc_Time(help_TimeText,(int)(Seconds*(100.0/Indicator->PercentValue)))==FL_EXT_INDICATOR_TIMEOK)
         fl_set_object_label(Indicator->EstimatedTimeText,help_TimeText);
      else
         fl_set_object_label(Indicator->EstimatedTimeText,"Overflow");
   }
}


void fl_ext_start_indicator(IndicatorType *Indicator)
{  Indicator->StartTime=time(NULL);
}


void fl_ext_reset_indicator(IndicatorType *Indicator)
{  fl_set_object_label(Indicator->StateText,"");
   Indicator->State=FL_EXT_INDICATOR_INITIAL;
   Indicator->InnerBox->w=200;
   fl_redraw_object(Indicator->InnerBox);
   fl_set_object_color(Indicator->InnerBox,BOX_COL1,BOX_COL2);
   Indicator->InnerBox->w=0;
   fl_redraw_object(Indicator->InnerBox);
   fl_set_object_label(Indicator->PercentValueText,"0 %");
   Indicator->PercentValue=-1.0;
   fl_set_object_label(Indicator->ActualTimeText,"00:00:00");
   fl_set_object_label(Indicator->EstimatedTimeText,"00:00:00");
}


void fl_ext_update_indicator(IndicatorType *Indicator,int StateNew, double PercentValueNew)
{  char help_PercentValue[20];

   if (PercentValueNew>100.0)
      PercentValueNew=100.0;
   else if (PercentValueNew<0.0)
      PercentValueNew=Indicator->PercentValue;

   fl_freeze_form(Indicator->Form);

   sprintf(&(help_PercentValue[0]),"%i %%",(int)PercentValueNew);
   if ((PercentValueNew!=Indicator->PercentValue)&&   // Fortschritt
       (PercentValueNew>0.0))
   {  Indicator->InnerBox->w=(int)PercentValueNew*2;       // Balken verlaengern
      fl_redraw_object(Indicator->InnerBox);          // und neu zeichnen
      fl_set_object_label(Indicator->PercentValueText,help_PercentValue);
      Indicator->PercentValue=PercentValueNew;
   }
   if (StateNew!=Indicator->State)                    // Neuer State
   {  switch (StateNew)
      {  case FL_EXT_INDICATOR_STOPPED  :
                 fl_set_object_label(Indicator->StateText,"STOPPED");
                 fl_set_object_color(Indicator->InnerBox,INDICATOR_STOPPED_COL,0);
                 break;
         case FL_EXT_INDICATOR_RUNNING  :
                 fl_set_object_label(Indicator->StateText,"RUNNING");
                 fl_set_object_color(Indicator->InnerBox,INDICATOR_RUNNING_COL,0);
                 break;
         case FL_EXT_INDICATOR_FINISHED :
                 fl_set_object_label(Indicator->StateText,"FINISHED");
                 fl_set_object_color(Indicator->InnerBox,INDICATOR_FINISHED_COL,0);
                 break;
      }
      Indicator->State=StateNew;
   }
   fl_ext_time_indicator(Indicator,FL_EXT_INDICATOR_ACTUAL_AND_ESTIMATED_TIME);
   fl_unfreeze_form(Indicator->Form);
}


IndicatorType *fl_ext_add_indicator(FL_FORM *Form,int PosX,int PosY,
                int Width,int Height,int FL_Gravity)
{  int OffsetX=0;
   int OffsetY=0;
   FL_OBJECT *obj;
   IndicatorType *Indicator=getIndicator();

   if (Width<FL_EXT_INDICATOR_MINWIDTH)
      Width=FL_EXT_INDICATOR_MINWIDTH;
   else
      OffsetX=(int)((Width-FL_EXT_INDICATOR_MINWIDTH)/2);
   if (Height<FL_EXT_INDICATOR_MINHEIGHT)
      Height=FL_EXT_INDICATOR_MINHEIGHT;
   else
      OffsetY=(int)((Height-FL_EXT_INDICATOR_MINHEIGHT)/2);

   Indicator->Form=Form;
   fl_addto_form(Indicator->Form);

      fl_ext_formobjects_add_frame(FL_ENGRAVED_FRAME,PosX,PosY,
            Width,Height,"",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+33,PosY+OffsetY+20,50,20,"Status:",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
      fl_ext_formobjects_add_text(&(Indicator->PercentValueText),FL_DOWN_BOX,
            PosX+OffsetX+100,PosY+OffsetY+20,50,20,"0 %",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(Indicator->PercentValueText,FL_ALIGN_CENTER);
         fl_set_object_bw(Indicator->PercentValueText,1);
      fl_ext_formobjects_add_text(&(Indicator->StateText),FL_DOWN_BOX,
            PosX+OffsetX+160,PosY+OffsetY+20,82,20,"",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(Indicator->StateText,FL_ALIGN_CENTER);
         fl_set_object_bw(Indicator->StateText,1);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+100,PosY+OffsetY+45,50,20,"Estimated",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(obj,FL_ALIGN_CENTER);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+192,PosY+OffsetY+45,50,20,"Actual",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(obj,FL_ALIGN_CENTER);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+33,PosY+OffsetY+65,100,20,"Total Time:",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
      fl_ext_formobjects_add_text(&(Indicator->EstimatedTimeText),FL_DOWN_BOX,
            PosX+OffsetX+100,PosY+OffsetY+65,50,20,"00:00:00",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(Indicator->EstimatedTimeText,FL_ALIGN_CENTER);
         fl_set_object_bw(Indicator->EstimatedTimeText,1);
      fl_ext_formobjects_add_text(&(Indicator->ActualTimeText),FL_DOWN_BOX,
            PosX+OffsetX+192,PosY+OffsetY+65,50,20,"00:00:00",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(Indicator->ActualTimeText,FL_ALIGN_CENTER);
         fl_set_object_bw(Indicator->ActualTimeText,1);
      fl_ext_formobjects_add_box2(&(Indicator->OuterBox),FL_DOWN_BOX,
            PosX+OffsetX+38,PosY+OffsetY+100,204,20,"",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
      fl_ext_formobjects_add_box2(&(Indicator->InnerBox),FL_FLAT_BOX,
            PosX+OffsetX+40,PosY+OffsetY+102,0,16,"",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+20,PosY+OffsetY+125,40,12,"0 %",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(obj,FL_ALIGN_CENTER);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+120,PosY+OffsetY+125,40,12,"50 %",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(obj,FL_ALIGN_CENTER);
      fl_ext_formobjects_add_text(&obj,FL_NO_BOX,
            PosX+OffsetX+220,PosY+OffsetY+125,40,12,"100 %",FL_RESIZE_NONE,FL_Gravity,FL_Gravity);
         fl_set_object_lalign(obj,FL_ALIGN_CENTER);
   fl_end_form();

   fl_ext_reset_indicator(Indicator);

   return Indicator;
}

void fl_ext_free_indicator(IndicatorType *Indicator)
{  returnIndicator(Indicator);
}


#include <sys/ipc.h>
#include <sys/sem.h>

void pv(int id, int operation)
{  static struct sembuf semaphor;

   semaphor.sem_num=0;
   semaphor.sem_op=operation;
   semaphor.sem_flg=SEM_UNDO;

   if (semop(id,&semaphor,1)==-1)
   {  printf("IPC-Error: PV-Operation failed on semaphor!\n");
      exit(-1);
   }
}


